//+------------------------------------------------------------------+ 
//|   TRO_HHMM_LINES                                                 | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window
//+------------------------------------------------------------------+

extern bool   Show.Gauge   = true ; 
extern bool   Show.Comment = true ; 
 
extern bool   Sound.Alert  = true ; 

extern int myChartX   = 10 ;
extern int myChartY   = 10 ;  
  
extern int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;
   

extern string myHHMM       = "00:00" ;  
extern int    myPeriod     = 0;

extern color  myTextColor = Gray;      
  
extern int    ShiftLabel  = 0;
extern color  myOpenColor = Orange; 
extern int    myOpenStyle = STYLE_SOLID;
extern int    myOpenWidth = 2;
 
extern color  myHighColor = Green; 
extern int    myHighStyle = STYLE_SOLID;
extern int    myHighWidth = 2;

extern color  myLowColor = Crimson; 
extern int    myLowStyle = STYLE_SOLID;
extern int    myLowWidth = 2;

extern color  myCloseColor = Blue; 
extern int    myCloseStyle = STYLE_SOLID;
extern int    myCloseWidth = 2;   

 
//+------------------------------------------------------------------+
string symbol, tChartPeriod,  tShortName, TAG="hhmmLine", ShortName ;  
int    digits, period, digits2  ; 
double point ;

string OBJ001, OBJ002 ; 
string lbl[15], lbl2[15];

double OpenPrice, LowerTrendLinePrice, UpperLimit, LowerLimit, xThreshold;

double  close,   Diff,   O,H,L,C ;

int n, j, k , bs;
int FillAmt = 11 , x001, x002, x003, x004, x005, x006, x007 ;  

color pColor = Blue  ;

double ThePrice ;
 
datetime var1 ;

string yymmddms ;
 

//+------------------------------------------------------------------+
int init()
{

   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
   
   tChartPeriod =  TimeFrameToString(period) ;


   yymmddms = TimeYear(Time[0]) + "." + TimeMonth(Time[0]) + "." + TimeDay(Time[0]) + " " + myHHMM   ;
    
   ShortName    = TAG + symbol + yymmddms ;
   OBJ001       = TAG + "001" + yymmddms;
   OBJ002       = TAG + "002" + yymmddms;
      
Comment(yymmddms) ;

if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 0 ;
   x002 = 0 ;
   x003 = 90 ; 
   x004 = 150;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;
   FillAmt = 20 ;     
}
else
{
   x001 = 0 ;
   x002 = 130 ; //  
   x003 = 50 ;  //  
   x004 = 0 ; //  
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;   
   FillAmt = 20 ; 
}
        
  
   deinit(); 
     
   return(0);
}


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
}
    
//+------------------------------------------------------------------+
int deinit()
{
   Comment("") ;
       
   ObDeleteObjectsByPrefix(TAG);
   
   TRO() ;
   
   return(0);
}
  

//+------------------------------------------------------------------+ 
    
int start()
{
     
      var1     = StrToTime(yymmddms); 
      
      bs       = iBarShift(NULL,myPeriod,var1,false) ;
      
      C = iClose(NULL,myPeriod,bs) ;  
      O = iOpen(NULL,myPeriod,bs)  ;  
      H = iHigh(NULL,myPeriod,bs)  ;  
      L = iLow(NULL,myPeriod,bs)   ;  
      
 
n       = 10;
j       = 0 ;

close        = iClose( symbol, 0, 0) ;
 

if(Show.Gauge) 
{
lbl[j]  = ShortName+j;
lbl2[j] = fFill(tChartPeriod + "   Value    +/-", 18) ;
DoShowHead(j, myTextColor);


j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Open " ;
DoColor( close, O  ) ; 
DoShow(j, myOpenColor, O, Diff ); 

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "High " ;
DoColor( close, H  ) ; 
DoShow(j, myHighColor, H, Diff ); 

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Low  " ;
DoColor( close, L  ) ; 
DoShow(j, myLowColor, L, Diff ); 

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Close" ;
DoColor( close, C  ) ; 
DoShow(j, myCloseColor, C, Diff ); 

j       = j + 1 ; 
lbl[j]  = ShortName+j;
lbl2[j] = fFill(yymmddms, 18) ;
DoShowHead(j, myTextColor); 
 
} // if
   
drawLine(O,"OP"+yymmddms, myOpenColor,myOpenStyle ,"Open "+myHHMM);
drawLine(H,"Hi"+yymmddms, myHighColor,myHighStyle ,"High "+myHHMM);
drawLine(L,"Lo"+yymmddms, myLowColor,myLowStyle ,"Low "+myHHMM);
drawLine(C,"CL"+yymmddms, myCloseColor,myCloseStyle ,"Close "+myHHMM);
   
if(Show.Comment) 
{
Comment(
 
"Date Time " , yymmddms , "\n" , 

"O = " , DoubleToStr(O,Digits) , "\n" , 
"H = " , DoubleToStr(H,Digits) , "\n" , 
"L = " , DoubleToStr(L,Digits) , "\n" , 
"C = " , DoubleToStr(C,Digits) , "\n" , 

 
"Ask Price = " , DoubleToStr(Ask,Digits) , "\n" ,
"Bid Price = " , DoubleToStr(Bid,Digits) , "\n" ,
 
 
"") ;    
} // if
  
   WindowRedraw();
   
   return(0);
}
 

//+------------------------------------------------------------------+
  
void DoShowHead( int u, color dsColor )
{
string rlabelH = lbl[u] + "Head" ;
ObjectCreate(rlabelH,23,0,Time[0],PRICE_CLOSE);
ObjectSet(rlabelH, OBJPROP_CORNER, myCorner );
ObjectSet(rlabelH,OBJPROP_XDISTANCE, x001+myChartX);
ObjectSet(rlabelH,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(rlabelH,lbl2[u],myFontSize,myFont,dsColor);

n = n+20;

return(0);
}
//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor, double dsPrice, double dsDiff  )
{
ObjectCreate(lbl[u],23,0,Time,PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE,x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);

string Obj001 = lbl[u] + "price" ;
string sVal = fFill(DoubleToStr(dsPrice,digits), 7)    ;
ObjectCreate(Obj001,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj001, OBJPROP_CORNER, myCorner );
ObjectSet(Obj001,OBJPROP_XDISTANCE, x003+myChartX);
ObjectSet(Obj001,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj001,sVal,myFontSize,myFont,dsColor);


string Obj002 = lbl[u] + "dif" ;
string sDif =  rtadjust( DoubleToStr(dsDiff/point,0) ) ;
ObjectCreate(Obj002,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj002, OBJPROP_CORNER, myCorner );
ObjectSet(Obj002,OBJPROP_XDISTANCE, x004+myChartX);
ObjectSet(Obj002,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj002,sDif,myFontSize,myFont,pColor);


n = n+20;

   return(0);
  }

 
//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{
Diff = c1 - c2 ;
if(c1 > c2 ) { pColor = Lime ; } else {
if(c1 < c2 ) { pColor = Red ; } else { pColor = Yellow ; } } 

}   
//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}



//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;

}       
    

//+------------------------------------------------------------------+
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}

//+------------------------------------------------------------------+
void drawLine(double lvl,string name, color Col,int type,string text)
{

         name = TAG + name;
         
         ObjectDelete(name) ;
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND,  0, 0, 0, 0, 0);
 
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            ObjectSet(name,OBJPROP_RAY,false);
            ObjectMove(name,0,var1,lvl);
            ObjectMove(name,1,Time[0],lvl );             
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, Time[0], lvl,Time[1],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
            ObjectSet(name,OBJPROP_RAY,false);
          
         }
      
   string Obj0002 = name+"linelbl" ;
      text = text + " " + DoubleToStr(lvl, digits)  ;
      ObjectDelete(Obj0002);
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, Time[ShiftLabel], lvl);
         ObjectSetText(Obj0002,text , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, Time[ShiftLabel], lvl);
      }          
         
         
}

//+------------------------------------------------------------------+ 